﻿// Created by: X
// Web: http://www.createdbyx.com/
// Date: January 28, 2008
// =============================================

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MMOTester
{
    public partial class Form1 : Form
    {

        MMO_Objects.Actor actor = new MMO_Objects.Actor();

        public Form1()
        {
            InitializeComponent();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.actor.Items.Add(new MMO_Objects.Book_MakingASimpleKnife(this.actor));
        }

        private void button3_Click(object sender, EventArgs e)
        {
            this.actor.Items.Add(new MMO_Objects.Steel(this.actor));
        }

        private void button4_Click(object sender, EventArgs e)
        {
            this.actor.Items.Add(new MMO_Objects.Rubber(this.actor));
        }

        private void button1_Click(object sender, EventArgs e)
        {
            MMO_Objects.IItem item;
            try
            {
                item = (MMO_Objects.IItem)this.lvActorItems.SelectedItems[0].Tag;
            }
            catch (Exception)
            {
                return;
            }

            // call execute on the item
            item.Execute();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.actor.Name = "Joe";

            this.actor.Items.AfterAdded += new MMO_Objects.GenericCollection<MMO_Objects.IItem>.AfterAddedEventHandler(Items_AfterAdded);
            this.actor.Items.AfterInsert += new MMO_Objects.GenericCollection<MMO_Objects.IItem>.AfterInsertEventHandler(Items_AfterInsert);
            this.actor.Items.AfterRemove += new MMO_Objects.GenericCollection<MMO_Objects.IItem>.AfterRemoveEventHandler(Items_AfterRemove);
            this.actor.Items.BeforeRemoveAt += new MMO_Objects.GenericCollection<MMO_Objects.IItem>.BeforeRemoveAtEventHandler(Items_BeforeRemoveAt);

            this.actor.Knowledge.AfterAdded += new MMO_Objects.GenericCollection<MMO_Objects.IKnowledge>.AfterAddedEventHandler(Knowledge_AfterAdded);
            this.actor.Knowledge.AfterInsert += new MMO_Objects.GenericCollection<MMO_Objects.IKnowledge>.AfterInsertEventHandler(Knowledge_AfterInsert);
            this.actor.Knowledge.AfterRemove += new MMO_Objects.GenericCollection<MMO_Objects.IKnowledge>.AfterRemoveEventHandler(Knowledge_AfterRemove);
            this.actor.Knowledge.BeforeRemoveAt += new MMO_Objects.GenericCollection<MMO_Objects.IKnowledge>.BeforeRemoveAtEventHandler(Knowledge_BeforeRemoveAt);
        }

        void Knowledge_BeforeRemoveAt(object sender, ref bool Cancel, int Index)
        {
            MMO_Objects.IKnowledge Value = this.actor.Knowledge[Index];
            foreach (ListViewItem i in this.lvActorKnoledge.Items)
            {
                if (i.Tag == Value)
                {
                    i.Remove();
                    return;
                }
            }

        }

        void Knowledge_AfterRemove(object sender, MMO_Objects.IKnowledge Value)
        {
            foreach (ListViewItem i in this.lvActorKnoledge.Items)
            {
                if (i.Tag == Value)
                {
                    i.Remove();
                    return;
                }
            }
        }

        void Knowledge_AfterInsert(object sender, int Index, MMO_Objects.IKnowledge Value)
        {
            this.Knowledge_AfterAdded(sender, Value);
        }

        void Knowledge_AfterAdded(object sender, MMO_Objects.IKnowledge Value)
        {
            ListViewItem lvi = new ListViewItem(Value.Name);
            lvi.SubItems.Add(Value.Description);
            lvi.SubItems.Add(Value.Category);
            lvi.Tag = Value;
            this.lvActorKnoledge.Items.Add(lvi);
        }

        void Items_AfterInsert(object sender, int Index, MMO_Objects.IItem Value)
        {
            this.Items_AfterAdded(sender, Value);
        }

        void Items_BeforeRemoveAt(object sender, ref bool Cancel, int Index)
        {
            MMO_Objects.IItem Value = this.actor.Items[Index];
            foreach (ListViewItem i in this.lvActorItems.Items)
            {
                if (i.Tag == Value)
                {
                    i.Remove();
                    return;
                }
            }
        }

        void Items_AfterRemove(object sender, MMO_Objects.IItem Value)
        {
            foreach (ListViewItem i in this.lvActorItems.Items)
            {
                if (i.Tag == Value)
                {
                    i.Remove();
                    return;
                }
            }
        }

        void Items_AfterAdded(object sender, MMO_Objects.IItem Value)
        {
            ListViewItem lvi = new ListViewItem(Value.Name);
            lvi.SubItems.Add(Value.Description);
            lvi.SubItems.Add(Value.Category);
            lvi.Tag = Value;
            this.lvActorItems.Items.Add(lvi);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            MMO_Objects.IKnowledge item;
            try
            {
                item = (MMO_Objects.IKnowledge)this.lvActorKnoledge.SelectedItems[0].Tag;
            }
            catch (Exception)
            {
                return;
            }

            // call execute on the item
            item.Execute();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.actor.Items.Add(new MMO_Objects.Tin(this.actor));

        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.actor.Items.Add(new MMO_Objects.Copper(this.actor));
                      }

        private void button6_Click(object sender, EventArgs e)
        {
            this.actor.Items.Add(new MMO_Objects.Book_HowToSmeltBronze(this.actor));

        }

        private void button9_Click(object sender, EventArgs e)
        {
            ListViewItem item;
            try
            {
                item = this.lvActorItems.SelectedItems[0];
            }
            catch (Exception)
            {
                return;
            }

            // remove the item from the actor
            this.actor.Items.Remove((MMO_Objects.IItem)item.Tag);

            // remove from the list
            item.Remove();
        }

        private void button10_Click(object sender, EventArgs e)
        {
            ListViewItem item;
            try
            {
                item = this.lvActorKnoledge.SelectedItems[0];
            }
            catch (Exception)
            {
                return;
            }

            // remove the item from the actor
            this.actor.Knowledge.Remove((MMO_Objects.IKnowledge)item.Tag);

            // remove from the list
            item.Remove();
        }
    }
}
