// Created by: X
// Web: http://www.createdbyx.com/
// Date: January 7, 2008
// =============================================
using System;
using System.Collections.Generic;
using System.Text;

namespace MMO_Objects
{
    public class Book_HowToSmeltBronze : IItem
    {
        private Actor owner;

        public Book_HowToSmeltBronze(Actor owner)
        {
            if (owner == null) throw new ArgumentNullException("owner");
            this.owner = owner;
        }

        #region IItem Members

        string IItem.Description
        {
            get { return "Teaches how to smelt tin and copper and turn it into bronze"; }
        }

        string IItem.Name
        {
            get { return "Book: How to smelt bronze"; }
        }

        string IItem.Category
        {
            get { return "Learning"; }
        }

        Guid IItem.UID
        {
            get { return new Guid("ba5ebde0-498c-44b8-bf86-f07cb8e54b4f"); }
        }

        Actor IItem.Owner
        {
            get
            {
                return this.owner;
            }
        }

        void IItem.Execute()
        {
            // give the Actor knoledge on how to Smelting Bronze
            foreach (MMO_Objects.IKnowledge k in this.owner.Knowledge)
            {
                if (k.GetType().Equals(typeof(MMO_Objects.SmeltingBronze)))
                {
                    // just return because actor already has this knoledge
                    return;
                }
            }

            // give the actor knoledge
            MMO_Objects.SmeltingBronze skc = new SmeltingBronze(this.owner);
            this.owner.Knowledge.Add(skc);
        }

        #endregion
    }
}