﻿// Created by: X
// Web: http://www.createdbyx.com/
// Date: January 28, 2008
// =============================================
using System;
using System.Collections.Generic;
using System.Text;

namespace MMO_Objects
{
    public class Book_MakingASimpleKnife : BaseItem
    {

        public Book_MakingASimpleKnife(Actor owner)
        {
            if (owner == null) throw new ArgumentNullException("owner");
            this.owner = owner;
        }


        public override string Description
        {
            get { return "Teaches how to construct a sinple knife"; }
        }
      
       public override string Name
        {
            get { return "Book: How to make a simple knife"; }
        }

       public override string Category
        {
            get { return "Learning"; }
        }

        public override Guid UID
        {
            get { return new Guid("9fa3d214-8c22-4ee3-8f9b-1779d69f6cec"); }
        }

        public override void Execute()
        {
            // requires an owner to execute
            if (this.owner == null) return;

            // give the Actor knoledge on how to make as Weapon_SimpleKnife knife
            foreach (MMO_Objects.IKnowledge k in this.owner.Knowledge)
            {
                if (k.GetType().Equals(typeof(MMO_Objects.SimpleKnifeConstruction)))
                {
                    // just return because actor already has this knoledge
                    return;
                }
            }

            // give the actor knoledge
            MMO_Objects.SimpleKnifeConstruction skc = new SimpleKnifeConstruction(this.owner);
            this.owner.Knowledge.Add(skc);
        }
    }            
}
