﻿// Created by: X
// Web: http://www.createdbyx.com/
// Date: January 28, 2008
// =============================================
using System;
using System.Collections.Generic;
using System.Text;

namespace MMO_Objects
{
    public class SimpleKnifeConstruction : IKnowledge
    {

        private Actor owner;

        public SimpleKnifeConstruction(Actor owner)
        {
            if (owner == null) throw new ArgumentNullException("owner");
            this.owner = owner;
        }

        #region IKnowledge Members

        string IKnowledge.Category
        {
            get { return "Weapon Construction"; }
        }

        Guid IKnowledge.UID
        {
            get { return new Guid("a2d6ea2a-4840-4b67-aa7a-d5356bc116f2"); }
        }

        string IKnowledge.Name
        {
            get { return "Simple knife construction"; }
        }

        void IKnowledge.Execute()
        {
            // search for requirements
            int steel = -1;
            int rubber = -1;

            // try to find required items
            foreach (MMO_Objects.IItem i in this.owner.Items)
            {
                if (i.GetType().Equals(typeof(MMO_Objects.Steel)))
                {
                    steel = this.owner.Items.IndexOf(i);
                }
                else if (i.GetType().Equals(typeof(MMO_Objects.Rubber)))
                {
                    rubber = this.owner.Items.IndexOf(i);
                }
            }

            // check if the required items were found
            if (steel != -1 && rubber != -1)
            {
                // remove the items
                this.owner.Items.RemoveAt(Math.Max(steel, rubber));
                this.owner.Items.RemoveAt(Math.Min(steel, rubber));

                // add the knife
                MMO_Objects.Weapon_SimpleKnife sn = new Weapon_SimpleKnife(this.owner);
                this.owner.Items.Add(sn);
            }
        }

        Actor IKnowledge.Owner
        {
            get { return this.owner; }
        }

        string IKnowledge.Description
        {
            get { return "Requirements: 1 Silver,\n 1 Rubber"; }
        }

        #endregion

    }

  
}
