// Created by: X
// Web: http://www.createdbyx.com/
// Date: January 7, 2008
// =============================================

using System;
using System.Collections.Generic;
using System.Text;

namespace MMO_Objects
{
    public class SmeltingBronze : IKnowledge
    {

        private Actor owner;

        public SmeltingBronze(Actor owner)
        {
            if (owner == null) throw new ArgumentNullException("owner");
            this.owner = owner;
        }

        #region IKnowledge Members

        string IKnowledge.Category
        {
            get { return "Smelting"; }
        }

        Guid IKnowledge.UID
        {
            get { return new Guid("e09e6e7d-ccc8-445d-a2dc-a9ca0cc0f67d"); }
        }

        string IKnowledge.Name
        {
            get { return "Smelt Bronze"; }
        }

        void IKnowledge.Execute()
        {
            // search for requirements
            int tin = -1;
            int copper = -1;

            // try to find required items
            foreach (MMO_Objects.IItem i in this.owner.Items)
            {
                if (i.GetType().Equals(typeof(MMO_Objects.Tin)))
                {
                    tin = this.owner.Items.IndexOf(i);
                }
                else if (i.GetType().Equals(typeof(MMO_Objects.Copper)))
                {
                    copper = this.owner.Items.IndexOf(i);
                }
            }

            // check if the required items were found
            if (tin != -1 && copper != -1)
            {
                // check if within proximity of a forge


                // remove the items
                this.owner.Items.RemoveAt(Math.Max(tin, copper));
                this.owner.Items.RemoveAt(Math.Min(tin, copper));

                // add the knife
                MMO_Objects.Bronze sn = new Bronze(this.owner);
                this.owner.Items.Add(sn);
            }
        }

        Actor IKnowledge.Owner
        {
            get { return this.owner; }
        }

        string IKnowledge.Description
        {
            get { return "Requirements: 1 Tin,\n 1 Copper"; }
        }

        #endregion

    }
}